package sun.font;

import java.awt.geom.GeneralPath;
import java.awt.geom.Rectangle2D;
import java.awt.Rectangle;
import java.awt.geom.Point2D;

public abstract class FontStrike
{
    protected FontStrikeDisposer disposer;
    protected FontStrikeDesc desc;
    protected StrikeMetrics strikeMetrics;
    protected boolean algoStyle;
    protected float boldness;
    protected float italic;
    
    public FontStrike() {
        this.algoStyle = false;
        this.boldness = 1.0f;
        this.italic = 0.0f;
    }
    
    public abstract int getNumGlyphs();
    
    abstract StrikeMetrics getFontMetrics();
    
    abstract void getGlyphImagePtrs(int[] p0, long[] p1, int p2);
    
    abstract long getGlyphImagePtr(int p0);
    
    abstract void getGlyphImageBounds(int p0, Point2D.Float p1, Rectangle p2);
    
    abstract Point2D.Float getGlyphMetrics(int p0);
    
    abstract Point2D.Float getCharMetrics(char p0);
    
    abstract float getGlyphAdvance(int p0);
    
    abstract float getCodePointAdvance(int p0);
    
    abstract Rectangle2D.Float getGlyphOutlineBounds(int p0);
    
    abstract GeneralPath getGlyphOutline(int p0, float p1, float p2);
    
    abstract GeneralPath getGlyphVectorOutline(int[] p0, float p1, float p2);
}
